]> git.xonotic.org Git - xonotic/xonotic.git/blobdiff - misc/tools/xonotic-map-compiler-autobuild
demotc-race-record-extractor.sh: remove useless rc case (gametype name is always...
[xonotic/xonotic.git] / misc / tools / xonotic-map-compiler-autobuild
index ca824d7bf5d33efc849483b88072d7c29590c4c4..10a8e8708d1bd17ca51bf996747f7d43df290ee8 100755 (executable)
@@ -3,11 +3,11 @@
 set -e
 
 bspdir="$PWD/data"
-url_http=http://beta.xonotic.org/autobuild-bsp/
-url_ssh=xonotic-beta:autobuild-bsp/
+url_http=https://beta.xonotic.org/autobuild-bsp/
+url_ssh=xonotic-beta:./
 build_cachedir="$HOME/xonotic-map-compiler.cache/"
 screenshot_cachedir="$HOME/xonotic-map-screenshot.cache/"
-build_override="-bsp_timeout 5400 -vis_timeout 3600 -light_timeout 14400 -minimap_timeout 900 -scale_timeout 900"
+build_override="-bsp_timeout 3600 -vis_timeout 10800 -light_timeout 18000 -minimap_timeout 900 -scale_timeout 900 -timeout_stealing 0.8"
 screenshot_override="9 900 5 +g_ctf 1"
 
 getthemap_fail=false
@@ -44,13 +44,19 @@ pre2spam()
        url=$2
        branch=$3
        hash=$4
+       lasttime_formatted=$5
 
        branch=${branch##refs/heads/}
        branch=${branch##refs/remotes/}
        branch=${branch##origin/}
        hash=`echo "$hash" | cut -c 1-7`
 
-       echo "[$branch $hash] starting map compile of $map"
+       echo -n "[<font color=\"#FF00FF\">$branch</font> $hash] starting map compile of $map"
+       if [ -n "$lasttime_formatted" ]; then
+               echo ", last time it took $lasttime_formatted"
+       else
+               echo
+       fi
 }
 
 ss2spam()
@@ -73,9 +79,9 @@ ss2spam()
        fi
 
        if [ -n "$s_error" ]; then
-               echo "[$branch $hash] \ 34screenshots of $map could not be made: $s_error"
+               echo "[<font color=\"#FF00FF\">$branch</font> $hash] screenshots of $map <font color=\"#FF0000\">could not be taken: $s_error</font>"
        else
-               echo "[$branch $hash] screenshots of $map are available on $url"
+               echo "[<font color=\"#FF00FF\">$branch</font> $hash] screenshots of $map <a href=\"$url\">are available</a>"
        fi
 }
 
@@ -132,26 +138,26 @@ log2spam()
        s_failshaders=`echo "$s_failshaders" | sed "s, textures/, ,g"`
        s_failshaders=${s_failshaders# }
        if [ -n "$s_error" ]; then
-               echo -n "[$branch $hash] \ 34failed"
+               echo -n "[<font color=\"#FF00FF\">$branch</font> $hash] <font color=\"#FF0000\">failed</font>"
        else
-               echo -n "[$branch $hash] finished"
+               echo -n "[<font color=\"#FF00FF\">$branch</font> $hash] <font color=\"#00FF00\">finished</font>"
        fi
-       echo -n " map compile of $map ($url): $time sec"
+       printf " map compile of <a href=\"$url\">$map</a> in %d:%02d:%02d" $((time/3600)) $((time%3600/60)) $((time%60))
        if [ -n "$s_samplesize" ]; then
-               echo -n ", FIX samplesize >= $s_samplesize"
+               echo -n "<br><font color=\"#FF0000\">FIX samplesize >= $s_samplesize</font>"
        fi
        if [ -n "$s_failshaders" ]; then
                if [ -n "`echo "$s_failshaders" | cut -d ' ' -f 4-`" ]; then
                        s_failshaders="`echo "$s_failshaders" | cut -d ' ' -f 1-3`..."
                fi
-               echo -n ", FIX shaders $s_failshaders"
+               echo -n "<br><font color=\"#FF0000\">FIX shaders $s_failshaders</font>"
        fi
        if [ -n "$s_leaked" ]; then
-               echo -n ", FIX LEAK"
+               echo -n "<br><font color=\"#FF0000\">FIX LEAK</font>"
        fi
        if [ -n "$s_error" ]; then
                s_error=`echo "$s_error" | sed "s,$PWD/\?,,g"`
-               echo -n ", ERROR: $s_error"
+               echo -n "<br><font color=\"#FF0000\">ERROR: $s_error</font>"
        fi
        echo
 }
@@ -164,22 +170,56 @@ buildthemap()
        blobhash=$4
        commithash=$5
        if lwp-request -m HEAD "$url$M-$blobhash.pk3"; then
-               continue
+               # already compiled
+               return
        fi
 
        git reset --hard
        git clean -xfd
        git checkout -f "$commithash"
 
+       mkdir -p ~/.xonotic-map-compiler-autobuild/ # to store map compile times in
+       lasttime=`cat ~/.xonotic-map-compiler-autobuild/"${M##*/}".buildtime 2>/dev/null || true`
+       if [ -n "$lasttime" ] ; then
+               lasttime_formatted=$(printf '%d:%02d:%02d' $((lasttime/3600)) $((lasttime%3600/60)) $((lasttime%60)) )
+               echo "Previous build took $lasttime_formatted"
+       fi
        if [ -n "$IRCSPAM" ]; then
-               pre2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$commithash" | $IRCSPAM || true
+               pre2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$commithash" "$lasttime_formatted" | $IRCSPAM || true
        fi
+
        t0=`date +%s`
-       (
+
+       # It's sad that we must enforce this rule by code.
+       if grep -- '-nosRGB' "maps/$M.map.options" >/dev/null; then
+               is_nosrgb=true
+       else
+               is_nosrgb=false
+       fi
+       allow_build=true
+       if $is_nosrgb; then
+               case "$REFNAME" in
+                       master|refs/heads/master|origin/master|refs/remotes/origin/master)
+                               if [ -n "$IRCSPAM" ]; then
+                                       echo "\ 34ERROR: map $M uses -nosRGB. This is not acceptable in master. Please fix." | $IRCSPAM || true
+                               fi
+                               allow_build=false
+                               ;;
+                       *)
+                               if [ -n "$IRCSPAM" ]; then
+                                       echo "\ 34WARNING:\ f map $M uses -nosRGB. This is not acceptable in master. Please fix." | $IRCSPAM || true
+                               fi
+                               ;;
+               esac
+       fi
+
+       set +e
+       $allow_build && (
                cd ../..
-               misc/tools/xonotic-map-compiler-optionsfile "data/xonotic-data.pk3dir/maps/$M" $build_override > "data/xonotic-data.pk3dir/maps/$M.log" 2>&1
+               misc/tools/xonotic-map-compiler-optionsfile "data/xonotic-maps.pk3dir/maps/$M" $build_override > "data/xonotic-maps.pk3dir/maps/$M.log" 2>&1
        )
        status=$?
+       set -e
        if ! [ -f "maps/$M.bsp" ]; then
                echo >>"maps/$M.log" "ERROR: No BSP file"
        fi
@@ -188,6 +228,9 @@ buildthemap()
        if [ -n "$IRCSPAM" ]; then
                cat "maps/$M.log" | log2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$commithash" "$status" "$dt" > "maps/$M.irc"
        fi
+       if [ $status -eq 0 ]; then
+               echo "$dt" > ~/.xonotic-map-compiler-autobuild/"${M##*/}".buildtime # save time in ~/.xonotic-map-compiler-autobuild/mapname
+       fi
        zip -9r "$M-$blobhash.pk3" "maps/$M.bsp" "maps/$M.log" "maps/$M.irc" "maps/$M/" "maps/$M.lin" "gfx/${M}_mini.tga"
        ln -snf "../$M-$blobhash.pk3" "$M.pk3" # from ALL branches, so beware!
        cp "$M-$blobhash.pk3" "$M-full-$blobhash.pk3"
@@ -210,13 +253,19 @@ screenshotthemap()
        M=$3
        blobhash=$4
        commithash=$5
-       if lwp-request -m HEAD "$url$M-$blobhash/"; then
-               continue
+       if ! [ -f "$bspdir/$M-$blobhash.pk3" ]; then
+               # not downloaded yet
+               return
+       fi
+
+       if lwp-request -m HEAD "$url$M-$blobhash/$M-000000.jpg"; then
+               # already done
+               return
        fi
 
        if ! unzip -l "$bspdir/$M-$blobhash.pk3" "maps/$M.bsp"; then
                # no BSP file
-               continue
+               return
        fi
 
        rm -rf ~/.xonotic/data
@@ -238,10 +287,10 @@ screenshotthemap()
        ) 2>&1 | tee ~/.xonotic/data/autoscreenshot.log
        good=false
        if mv ~/.xonotic/data/screenshots "$M-$blobhash"; then
-               ss2spam "$M" "$url?d" "$REFNAME" "$commithash" 0 > ~/.xonotic/data/"$M.ircss"
+               ss2spam "$M" "$url$M-$blobhash/" "$REFNAME" "$commithash" 0 > ~/.xonotic/data/"$M.ircss"
        else
                mkdir "$M-$blobhash"
-               ss2spam "$M" "$url?d" "$REFNAME" "$commithash" 1 > ~/.xonotic/data/"$M.ircss"
+               ss2spam "$M" "$url$M-$blobhash/" "$REFNAME" "$commithash" 1 > ~/.xonotic/data/"$M.ircss"
        fi
        mv ~/.xonotic/data/"$M.ircss" "$M-$blobhash"/
        mv ~/.xonotic/data/autoscreenshot.log "$M-$blobhash"/
@@ -250,6 +299,9 @@ screenshotthemap()
        rsync -vaSHP "$M-$blobhash" "$url_ssh"
        rsync -vaSHP "$M" "$url_ssh""latest/"
        if [ -n "$IRCSPAM" ]; then
+               # It takes about 5 minutes for the server to update.
+               sleep 360  # Cut it one more minute of slack.
+
                $IRCSPAM < "$M-$blobhash/$M.ircss" || true
        fi
        if [ -n "$BUILD_ONE" ]; then
@@ -271,7 +323,7 @@ getthemap()
                fi
        fi
        if ! wget -c -O "$bspdir/$M-$blobhash.pk3" "$url$M-$blobhash.pk3"; then
-               if ! curl -o "$bspdir/$M-$blobhash.pk3" "$url$M-$blobhash.pk3"; then
+               if ! curl -Lo "$bspdir/$M-$blobhash.pk3" "$url$M-$blobhash.pk3"; then
                        rm -f "$bspdir/$M-$blobhash.pk3"
                        echo "WARNING: could not download $url$M-$blobhash.pk3, maybe not ready yet"
                        getthemap_fail=true
@@ -346,13 +398,17 @@ case "$1" in
                        git clean -xfd
                        git checkout -f "$HASH"
 
+                       getthemap_fail=false
                        rundownload
+
+                       allmaps "$HASH" screenshotthemap "$REFNAME" "$url_http"
+
                        if $getthemap_fail; then
+                               # If any map fetch failed, we've skipped them and thus need to try again later.
+                               # Note that we're not going to re-screenshot maps because of this as we'll check for uploaded screenshots first.
                                continue
                        fi
 
-                       allmaps "$HASH" screenshotthemap "$REFNAME" "$url_http"
-
                        touch "$screenshot_cachedir/$HASH"
                done
                git checkout -f master